
#include "Map.h"
#include "time_util.h"
#include "connectivity.h"

#pragma once

class NodeTable;

class EndSearch
{
    public:
    EndSearch(StopWatch* sw, NodeTable* table, cnct::TreeSizeCache* tsc);
    int search(Map& start_pos);
    int search(Map& start_pos, int side, int depth, int low_score,
            Bound& bound);
    private:
    StopWatch* clock;
    NodeTable* ttable;
    cnct::TreeSizeCache* tscache;
    int tthit, ttscore;

    int dfs(Map& position, int depth, int low_score, int high_score,
            Bound& bound);
};

