
#define __STDC_CONSTANT_MACROS

#include <string>
#include <vector>

#if defined(_MSC_VER)
  typedef unsigned __int64 uint64_t;
  #define UINT64_C(c) c ## ULL
#else
  #include <inttypes.h>
#endif

#pragma once

/*
void combine_territory(uint64_t* territory, uint64_t* addition);
bool find_territory(Map& position, uint64_t*& p1terr, uint64_t*& p2terr);
int territory_size(uint64_t* territory, int* start);
int open_neighbors(Map& position, int* point);
int space_available(const Map& position, int* point);
*/

int bitindex(uint64_t bit);

class Territory
{
    public:
    static void preallocate();
    static Territory* allocate();
    static Territory* allocate(const Territory& other);
    static Territory* free(Territory* territory);

    std::string& toString();

    void clear();
    bool not_empty();
    void expand();
    bool contains(int* point);
    bool contains(int x, int y);
    int size(int* start);
    int size(int* start, int* end);
    int neighbors(int* point);
    int space_available(int* start);
    bool separate(int* p1start, int* p2start,
            Territory& p1terr, Territory& p2terr);
    bool set_and_clear_overlap(Territory& p1terr, Territory& p2terr);
    void fill_from(const Territory& other, int* start);
    bool overlap(const Territory& other);

    void andnot(const Territory& other);
    Territory& operator = (const Territory& other);
    Territory& operator |= (const Territory& other);
    Territory& operator &= (const Territory& other);
    uint64_t& operator [] (const int column);
    bool operator == (const Territory& other);
    bool operator != (const Territory& other);

#ifdef MEMORY_CHECK
    static int allocated;
    static int unreturned();
#endif
    private:
    static std::vector<Territory*> cache;
    Territory();
    Territory(const Territory& other);
    ~Territory();

    uint64_t* area;

};

class TerritoryIter
{
    public:
    TerritoryIter(Territory* t);
    bool has_more();
    int* next();

    int current[2];

    private:
    Territory* terr;
    int x;
    uint64_t column;

    bool next_col();
};

